<?php
namespace FM\Service;

use FM\Factory\RelatoriosVistoriaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class RelatoriosVistoriaService {

    protected $RelatoriosVistoriaFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (RelatoriosVistoriaFactory $RelatoriosVistoriaFactory, Environment $Environment, NewCode $newCode) {
        $this->RelatoriosVistoriaFactory  = $RelatoriosVistoriaFactory;
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function getFuncionarios() {
        return $this->RelatoriosVistoriaFactory->getFuncionarios();
    }

    public function getRelatoriosVistoria() {
        return $this->RelatoriosVistoriaFactory->getRelatoriosVistoria();
    }

    public function getCriteriosVistoria($parametros) {
        return $this->RelatoriosVistoriaFactory->getCriteriosVistoria($parametros['NRGERENCIAMENTOCHK']);
    }

    public function getFotosVistoria($parametros) {
        return $this->RelatoriosVistoriaFactory->getFotosVistoria($parametros['NRGERENCIAMENTOCHK']);
    }
}