/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPORETI                                                     */
/* Tabela : TIPORETI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 06/08/2005 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPORETI
BEFORE INSERT OR UPDATE OR DELETE
ON TIPORETI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTIRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMTIPORETI,0) <> NVL(:NEW.NMTIPORETI,0)) OR
         (NVL(:OLD.CDTIPORETI,0) <> NVL(:NEW.CDTIPORETI,0)) THEN
         :NEW.DTULTATUTIRE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPORETI', '', 'CDTIPORETI='||:OLD.CDTIPORETI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPORETI MODIFY DTULTATUTIRE DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPORETI','4.05.081'); END;
/

