/* Nome:  0315_plafun_custo_prato                            */


/* Descrio: Busca o custo dos pratos no dia                */ 


/* Retorno: Custos do Prato                                  */  


/* Criao: Paulo H. Mariano                                */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                  WHERE 
            O.name = 'CUSTO_PRATO' AND
            TYPE   = 'P'             AND
            U.uid  = O.uid          AND
            U.name = USER)
 DROP FUNCTION CUSTO_PRATO
 GO
 
 CREATE FUNCTION CUSTO_PRATO(
                             @P_CDFILIAL     VARCHAR(4),
                             @P_CDFILICUSTO  VARCHAR(4),
                             @P_NRTIPOCUSTO  NUMERIC(10),
                             @P_DTREFERENCIA DATETIME,
                             @P_CDFILAUXPRAT VARCHAR(4),
                             @P_CDPRATO      VARCHAR(10),
                             @P_CDSERVFILI   VARCHAR(5)) RETURNS FLOAT
                              
 AS
 BEGIN 
    DECLARE @V_IDUTILFATCOR   VARCHAR(1);
    DECLARE @V_IDUTILFATCOC   VARCHAR(1);
    DECLARE @V_IDTIPCALCFAT   VARCHAR(1);

    DECLARE @V_CDPRODUTO   VARCHAR(10);
    DECLARE @V_QTPRODUTO   NUMERIC(15,6);
    DECLARE @V_CUSTO_PRATO NUMERIC(15,6);
    DECLARE @V_QTPRODREC   NUMERIC(15,6);
    DECLARE @V_SGUNIDADE   VARCHAR(5);
    DECLARE @V_VRPEFATCOC  NUMERIC(15,6);
    DECLARE @V_VRPEFATCOR  NUMERIC(15,6);

    DECLARE @V_CUSTO_DO_PRODUTO NUMERIC(15,6);
    DECLARE @V_QTDE_UNIDADE_ESTOQUE NUMERIC(15,6);
 BEGIN
    
    DECLARE C_CUSTO_DO_PRATO CURSOR FOR
    (SELECT
       CDPRODUTO,
       QTBRUTASE AS QTPRODUTO
     FROM
       RECESERV
     WHERE
       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
       (CDPRATO      = @P_CDPRATO)      AND
       (CDFILIAL     = @P_CDFILIAL)     AND
       (CDSERVFILI   = @P_CDSERVFILI)  )
       
    UNION

    SELECT
       CDPRODUTO,
       QTBRUTALO AS QTPRODUTO
    FROM
       RECEFILI
    WHERE
       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
       (CDPRATO      = @P_CDPRATO)      AND
       (CDFILIAL     = @P_CDFILIAL)     AND
       NOT EXISTS (SELECT
                       CDPRATO
                    FROM
                       RECESERV
                    WHERE
                       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
                       (CDPRATO      = @P_CDPRATO)      AND
                       (CDFILIAL     = @P_CDFILIAL)     AND
                       (CDSERVFILI   = @P_CDSERVFILI)
                    )
    UNION

    SELECT
       CDPRODUTO,
       QTBRUTAPR  AS QTPRODUTO
    FROM
       RECEPADR
    WHERE
       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
       (CDPRATO      = @P_CDPRATO)      AND
             NOT EXISTS (SELECT
                       CDPRATO
                    FROM
                       RECEFILI
                    WHERE
                       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
                       (CDPRATO      = @P_CDPRATO)      AND
                       (CDFILIAL     = @P_CDFILIAL)
                    ) AND
        NOT EXISTS (SELECT
                       CDPRATO
                    FROM
                       RECESERV
                    WHERE
                       (CDFILAUXPRAT = @P_CDFILAUXPRAT) AND
                       (CDPRATO      = @P_CDPRATO)      AND
                       (CDFILIAL     = @P_CDFILIAL)     AND
                       (CDSERVFILI   = @P_CDSERVFILI)
                    );
   SELECT
      @V_IDUTILFATCOR = MAX(IDUTILFATCOR),
      @V_IDUTILFATCOC = MAX(IDUTILFATCOC),
      @V_IDTIPCALCFAT = MAX(IDTIPCALCFAT)
   FROM
      PARAMPLANEJA
   WHERE
      CDFILIAL = @P_CDFILIAL;

   IF @V_IDUTILFATCOR IS NULL
   BEGIN
      SET @V_IDUTILFATCOC = 'S';
      SET @V_IDUTILFATCOR = 'S';
      SET @V_IDTIPCALCFAT = 'T';
   END;
   
   SET @V_CUSTO_PRATO = 0;

   OPEN C_CUSTO_DO_PRATO;

   FETCH NEXT FROM C_CUSTO_DO_PRATO INTO @V_CDPRODUTO, @V_QTPRODUTO;
   WHILE (@@FETCH_STATUS = 0)
      BEGIN

         SELECT @V_CUSTO_DO_PRODUTO = TEKNISA.CUSTO_PRODUTO (@P_CDFILICUSTO, @V_CDPRODUTO, @P_NRTIPOCUSTO, @P_DTREFERENCIA, GETDATE());
             
         SET @V_CUSTO_PRATO = @V_CUSTO_PRATO + (ROUND(@V_QTPRODUTO, 5) * ROUND(@V_CUSTO_DO_PRODUTO, 5));

         FETCH NEXT FROM C_CUSTO_DO_PRATO INTO @V_CDPRODUTO, @V_QTPRODUTO;
      END;
   END;
   CLOSE C_CUSTO_DO_PRATO;
   --DEALLOCATE C_CUSTO_DO_PRATO;

   RETURN(ROUND(@V_CUSTO_PRATO, 5));
  /* SET @P_CUSTO_PRATO = ROUND(@V_CUSTO_PRATO, 5);*/
END;
GO

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_PRATO','5.50.000'); 



